import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class colormixguess2export extends PApplet {



int white, black;


// color changes with the background
int back; // color of the background



float shiftx=840; //shift of the main field
float shifty=90;

float shifth=30; //shift of the hue slider from the main field
float band=30; // hue slider width

float cell=1; //cell size
float huee, satu, brig;

float frame=30; //white background for the picker


float huu; //picked hue
float bri; //picked brightness
float sat; //picked saturation
int pick; //picked color


float r, g, b; //rgb values of pickes color
float rgb; // grayscale value of picked color



float xx, yy; //main field
float yyy; // hue slider



int[] c= new int[5];
int inter1, inter2, inter3, inter4;


// images
PImage scale, bw, showw, showb, neww, newb, footerw, footerb;

int counter;
boolean sshow;

// comparing colors
float rr, gg, bb, rrr, ggg, bbb;
float score;
float scorepoint; // score position on the scale


 PFont font;
 
 
 int circle;



// ==========================================





public void setup(){
  
  
  
  scale=loadImage("scale.png");
  bw=loadImage("bw.png");
  showw=loadImage("showw.png");
  showb=loadImage("showb.png");
  neww=loadImage("neww.png");
  newb=loadImage("newb.png");
  footerw=loadImage("footerw.png");
  footerb=loadImage("footerb.png");

  
  


  
  
  xx=shiftx+13;
  yy=shifty+13;
  yyy=shifty+1+127;
  
  
  huu=124;
  sat=12.75f;
  bri=242;
  
  colorMode(RGB, 255, 255, 255);
  
  for(int x=0; x<5; x++){
    
   c[x]=color(random(255), random(255), random(255)); 
  }
  
  
  white=color(255); // white
  black=color(0); // black
  
  back=white; 
  counter=2; // bw switch
  
  sshow=false; // clicking show button
  
  font = loadFont("GothamRounded-Book-24.vlw");
  textFont(font);
  textSize(24);
  textAlign(CENTER);
  
  circle=black;
  
  rgb=255;
  

}





// ==========================================





public void draw(){
  if(counter%2==0){
   back=white; 
  }
  else
  {
    back=black;
  }
  
  
  //c[2]=black;
  
  
  background(back);
  
  
  
  
  
  
 
// ========== COLOR PICKER

colorMode(HSB, 255, 255, 255);

//hue slider
 noStroke();
 for(int x=0; x<256; x++){
   fill(x, 255, 255);
   rect(shiftx+(256*cell)+shifth, x+shifty, band, cell);
  }  
   
   //frame for hue slider
 noFill();
 if(back==white){
 stroke(0, 0, 0);
 }
 else{
 stroke(0, 0, 255);
 }
 
 rect(shiftx+(256*cell)+shifth-1, shifty-1, band+1, (cell*256)+1);
  
  
  
  
  //main field
  noStroke();
 for(int y=0; y<256; y++){
  for(int x=0; x<256; x++){
    satu=x;
    brig=255-y;
   fill(huu, satu, brig);
   rect(x+shiftx, y+shifty, cell, cell);

  }
 }
 
 //frame for main field
 noFill();
 if(back==white){
 stroke(0, 0, 0);
 }
 else{
 stroke(0, 0, 255);
 }
 rect(shiftx-1, shifty-1, (cell*256)+1, (cell*256)+1);
 
 
 //hue slider action
 if(mousePressed == true && ((mouseX >=shiftx+(256*cell)+shifth && mouseX<=shiftx+(256*cell)+shifth+band-1) && (mouseY>=shifty && mouseY<=shifty+(256*cell)-1))){
 //cursor(CROSS);
   huu=hue(get(mouseX, mouseY));
   
   
   

 }
 
 //hue slider action
 
 noFill();
   if(back==white){
 stroke(0, 0, 0);
 }
 else{
 stroke(0, 0, 255);
 }
   line(shiftx+(256*cell)+shifth-1, yyy, shiftx+(256*cell)+shifth-1-10, yyy);
   
   line(shiftx+(256*cell)+shifth+band, yyy, shiftx+(256*cell)+shifth+10+band, yyy);
 
 
 //main field action
 if(mousePressed == true && ((mouseX >=shiftx && mouseX<shiftx+(256*cell)) && (mouseY>=shifty && mouseY<=shifty+(256*cell)-1))){
 
   sat=mouseX-shiftx;
   bri=255-(mouseY-shifty);
   
   r=red(get(mouseX, mouseY));
   g=green(get(mouseX, mouseY));
   b=blue(get(mouseX, mouseY));
   
   rgb=((r * 0.2126f) + (g* 0.7152f) + (b * 0.0722f));
   
   

 }
 
 
 //circle in the main field
 noFill();

   stroke(255-rgb);
   ellipse(xx, yy, 20, 20);
 
 
 
 pick=color(huu, sat, bri);
 
 
 
 
 
   // ======= picked field
 noStroke();
 fill(pick);
 
 rect(840, 385, 159, 85);
 
 
 
 // ========== 5 SQUARES
 
 
 colorMode(RGB, 255, 255, 255);
 
 noStroke();
 
 fill(c[0]);
 rect(280, 90, 190, 190);
 fill(c[1]);
 rect(90, 280, 190, 190);
 fill(c[3]);
 rect(470, 280, 190, 190);
 fill(c[4]);
 rect(280, 470, 190, 190);
 
 fill(c[2]);
 rect(280, 280, 190, 190);
 
 //quads
 inter1=lerpColor(c[0], c[2], 0.5f);
 inter2=lerpColor(c[1], c[2], 0.5f);
 inter3=lerpColor(c[3], c[2], 0.5f);
 inter4=lerpColor(c[4], c[2], 0.5f);
 
 
 fill(inter1);
 quad(280, 280, 375, 185, 470, 280, 375, 375);
 
 fill(inter2);
 quad(280, 280, 185, 375, 280, 470, 375, 375);
 
 fill(inter3);
 quad(375, 375, 470, 280, 565, 375, 470, 470);
 
 fill(inter4);
 quad(375, 375, 470, 470, 375, 565, 280, 470);
 
 
 
 // ======= mistery field
 if(sshow==true){
 noStroke();
 fill(c[2]);
 
 rect(999, 385, 159, 85);
 
 } 
 
  
  
  //========= buttons and images
  
  // bw button
  image(bw, 1120, 622);
  
  // new button
  if(back==white){
   image(neww, 840, 622); 
  }
  else
  {
   image(newb, 840, 622);  
  }
  
  
  // show button
  
  if(back==white){
   image(showw, 937, 622); 
  }
  else
  {
   image(showb, 937, 622);  
  }
  
  
  // scale
  if(sshow==true){
  image(scale, 840, 541); 
  }
  
  //footer
 if(back==white){
   image(footerb, 0, height-50); 
  }
  else
  {
   image(footerw, 0, height-50);  
  }
  
  
  // score
  
  rr=red(c[2]);
  gg=green(c[2]);
  bb=blue(c[2]);
  
  
  rrr=red(pick);
  ggg=green(pick);
  bbb=blue(pick);
  
  score=dist(rr, gg, bb, rrr, ggg, bbb);
  

  
  // score triangle
  scorepoint=318-((318*score)/442);
  
  if(back==white){
    fill(black);
  }
  else
  {
    fill(white);
  }
  
  if(sshow==true){
  triangle(840+scorepoint, 541, 840+scorepoint-5, 541-10, 840+scorepoint+5, 541-10);
  }
  
  //score number
  if(back==white){
    fill(black);
  }
  else
  {
    fill(white);
  }
  
  if(sshow==true){
  text(str(PApplet.parseInt(score)), 840+scorepoint, 525);
}



// divider
if(back==white){
    stroke(220);
  }
  else
  {
    stroke(50);
  }
  
  line(750, 0, 750, 749);




}





// ==========================================





public void mousePressed(){
  
  if((mouseX >=shiftx && mouseX<=shiftx+(256*cell)) && (mouseY>=shifty && mouseY<=shifty+(256*cell)-1)){
   xx=mouseX;
   yy=mouseY; 
    
  }
  
  if((mouseX >=shiftx+(256*cell)+shifth && mouseX<=shiftx+(256*cell)+shifth+band-1) && (mouseY>=shifty && mouseY<=shifty+(256*cell)-1)){
  
    yyy=mouseY;
    
  }
  
  // bw button
  if ((mouseX>=1120 && mouseX <=1120+38) && (mouseY>=622 && mouseY <= 622+38)){
    counter=counter+1;

  }
  
  // new button
  if((mouseX>=840 && mouseX<=840+80) && (mouseY>=622 && mouseY<= 622+38)){
  
  for(int x=0; x<5; x++){
    
   c[x]=color(random(255), random(255), random(255)); 
  }
  sshow=false;

  }
  
  //show button
  if((mouseX>=937 && mouseX<=937+80) && (mouseY>=622 && mouseY<= 622+38)){
 
  sshow=true;

  }
  
  
  
}





// ==========================================





public void mouseDragged(){
  
  if((mouseX >=shiftx && mouseX<=shiftx+(256*cell)) && (mouseY>=shifty && mouseY<=shifty+(256*cell)-1)){
   xx=mouseX;
   yy=mouseY; 
    
  }
  
  if((mouseX >=shiftx+(256*cell)+shifth && mouseX<=shiftx+(256*cell)+shifth+band-1) && (mouseY>=shifty && mouseY<=shifty+(256*cell)-1)){
  
    yyy=mouseY;
    
  }

}
  public void settings() {  size(1248, 800); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "colormixguess2export" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
